
{*******************************************************}
{                                                       }
{         Delphi VCL Extensions (ho)                    }
{            for  FastReport v2.2                       }
{     Text export filter (RTF Filter) Classes           }
{                                                       }
{     Copyright (c) 1996 - 1999 by Bartels Alex         }
{             JSIC "Energogarant"                       }
{             alex@msk-garant.ru                        }
{*******************************************************}

unit Fr_ertfClass;

interface
uses classes, graphics, sysutils;

type

 Tfr_word = record
   x,y:integer; {   }
   FontName:string; {   }
   FontSize:integer; {   }
   FontStyle: TFontStyles; {   }
   Value: string; {  }
   width:integer; {      }
  end;
 Pfr_word = ^Tfr_word;

 TfrWordList = class(TList)
   private
    procedure ClearData;
   public
    function AddWord(inX,inY:integer;inFont:TFont;inValue:string;inWidth:integer): Integer;
    destructor Destroy; override;
    procedure Clear;

    procedure SortData;{    Y  Data }
  end;

procedure CreateHeader(Stream:TStream);
 {    RTF }

procedure WriteString(Stream:TStream; Value:String);
 {     }

implementation

  {    Y,X }
function intCompare(Item1, Item2: Pointer): Integer;
begin
 result:=Tfr_word(Item1^).y-Tfr_word(Item2^).y;
 if Result=0 then
    result:=Tfr_word(Item1^).x-Tfr_word(Item2^).x;
end;

procedure TfrWordList.ClearData;
var
 i:integer;
begin
 for i:=0 to Count-1 do
   Dispose(items[i]);
end;

function TfrWordList.AddWord(inX,inY:integer;inFont:TFont;inValue:string;inWidth:integer): Integer;
var
 newItem:Pfr_word;
begin
 new(newItem);
 with newItem^ do
  begin
   X:=inX;
   Y:=inY;
   FontName:=inFont.Name;
   FontSize:=inFont.Size;
   FontStyle:=inFont.Style;
   Value:=inValue;
   Width:=inWidth;
  end;
 result:=add(newItem);
end;

destructor TfrWordList.Destroy;
begin
 ClearData;
 inherited;
end;

procedure TfrWordList.Clear;
begin
 ClearData;
 inherited Clear;
end;

procedure TfrWordList.SortData;{    Y  Data }
begin
 sort(intCompare);
end;

{    }
procedure WriteString(Stream:TStream; Value:String);
var
 s:string;
 b,i:integer;
begin
 if value = '' then Exit;
 s:='';
 for i:=1 to length(value) do
  begin
   b:=ord(value[i]);
   if b>127 then
     s:=s+'\'''+IntToHex(b,2)
    else
     s:=s+value[i];
  end;
 Stream.Write(s[1],Length(s));
end;

procedure CreateHeader(Stream:TStream);   //  
begin
 WriteString(stream,'{\rtf1\ansi\deff0\deftab720{\fonttbl');
 WriteString(stream,'{\f0\fnil ;}');
 WriteString(stream,'{\f1\froman Symbol;}');
 WriteString(stream,'{\f2\fswiss Arial;}');
 WriteString(stream,'{\f3\fswiss MS Sans Serif;}');
 WriteString(stream,'{\f4\fmodern Courier New;}');
 WriteString(stream,'{\f5\froman Times New Roman;}');

 WriteString(stream,'}');
 WriteString(stream,'{\colortbl');
 WriteString(stream,'\red0\green0\blue0;');
 WriteString(stream,'\red0\green0\blue255;');
 WriteString(stream,'\red0\green128\blue0;');
 WriteString(stream,'\red128\green0\blue0;');
 WriteString(stream,'}');
 WriteString(stream,' \paperw11907\paperh16840\psz9 '); {  A4 }
end;

end.
